package dev.shadowsoffire.apotheosis.ench.library;

import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import java.util.Arrays;
import net.minecraft.world.level.storage.loot.parameters.LootContextParams;
import java.util.List;
import net.minecraft.world.level.storage.loot.LootParams;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.nbt.Tag;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.phys.HitResult;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.StateDefinition;
import dev.shadowsoffire.placebo.menu.SimplerMenuProvider;
import net.minecraft.world.MenuProvider;
import dev.shadowsoffire.placebo.menu.MenuUtil;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.material.MapColor;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.network.chat.Component;
import net.minecraft.world.level.block.EntityBlock;
import net.minecraft.world.level.block.HorizontalDirectionalBlock;

public class EnchLibraryBlock extends HorizontalDirectionalBlock implements EntityBlock
{
    public static final Component NAME;
    protected final BlockEntityType.BlockEntitySupplier<? extends EnchLibraryTile> tileSupplier;
    protected final int maxLevel;
    
    public EnchLibraryBlock(final BlockEntityType.BlockEntitySupplier<? extends EnchLibraryTile> tileSupplier, final int maxLevel) {
        super(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283913_).m_60913_(5.0f, 1200.0f));
        this.tileSupplier = tileSupplier;
        this.maxLevel = maxLevel;
    }
    
    public InteractionResult m_6227_(final BlockState state, final Level world, final BlockPos pos, final Player player, final InteractionHand handIn, final BlockHitResult hit) {
        return MenuUtil.openGui(player, pos, EnchLibraryContainer::new);
    }
    
    public MenuProvider m_7246_(final BlockState state, final Level world, final BlockPos pos) {
        return (MenuProvider)new SimplerMenuProvider(world, pos, EnchLibraryContainer::new);
    }
    
    protected void m_7926_(final StateDefinition.Builder<Block, BlockState> builder) {
        builder.m_61104_(new Property[] { (Property)EnchLibraryBlock.f_54117_ });
    }
    
    public BlockState m_5573_(final BlockPlaceContext p_196258_1_) {
        return (BlockState)this.m_49966_().m_61124_((Property)EnchLibraryBlock.f_54117_, (Comparable)p_196258_1_.m_8125_().m_122424_());
    }
    
    public BlockEntity m_142194_(final BlockPos pPos, final BlockState pState) {
        return this.tileSupplier.m_155267_(pPos, pState);
    }
    
    public ItemStack getCloneItemStack(final BlockState state, final HitResult target, final BlockGetter world, final BlockPos pos, final Player player) {
        final ItemStack s = new ItemStack((ItemLike)this);
        final BlockEntity te = world.m_7702_(pos);
        if (te != null) {
            s.m_41784_().m_128365_("BlockEntityTag", (Tag)te.m_187482_());
        }
        return s;
    }
    
    public void m_6402_(final Level world, final BlockPos pos, final BlockState state, final LivingEntity placer, final ItemStack stack) {
        final BlockEntity te = world.m_7702_(pos);
        if (te != null) {
            te.m_142466_(stack.m_41698_("BlockEntityTag"));
        }
    }
    
    public List<ItemStack> m_49635_(final BlockState state, final LootParams.Builder ctx) {
        final ItemStack s = new ItemStack((ItemLike)this);
        final BlockEntity te = (BlockEntity)ctx.m_287261_(LootContextParams.f_81462_);
        if (te != null) {
            s.m_41784_().m_128365_("BlockEntityTag", (Tag)te.m_187482_());
        }
        return Arrays.asList(s);
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_5871_(final ItemStack stack, final BlockGetter world, final List<Component> list, final TooltipFlag advanced) {
        list.add((Component)Component.m_237110_("tooltip.enchlib.capacity", new Object[] { Component.m_237115_("enchantment.level." + this.maxLevel) }).m_130940_(ChatFormatting.GOLD));
        final CompoundTag tag = stack.m_41737_("BlockEntityTag");
        if (tag != null && tag.m_128441_("Points")) {
            list.add((Component)Component.m_237110_("tooltip.enchlib.item", new Object[] { tag.m_128469_("Points").m_128440_() }).m_130940_(ChatFormatting.GOLD));
        }
    }
    
    public void m_6810_(final BlockState state, final Level world, final BlockPos pos, final BlockState newState, final boolean isMoving) {
        if (newState.m_60734_() != this) {
            world.m_46747_(pos);
        }
    }
    
    static {
        NAME = (Component)Component.m_237115_("apotheosis.ench.library");
    }
}
